/*
 * Copyright (c) 2024 Erik Ridderby, ARCHEA.
 * All rights reserved.
 *
 * This source code is licensed under both the 
 * * BSD-3-Clause license with No Nuclear or Weapons use exception
 *   (found in the BSD-3-Clause-No-Nuclear-or-Weapons-License.txt file in 
 *   the root directory of this source tree) 
 *
 * and the 
 * 
 * * GPLv3 
 *   (found in the COPYING file in the root directory of this source tree).
 * 
 * You may select, at your option, one of the above-listed licenses.
 * 
 */
 

#ifndef SNOWFLAKEID_H
#define SNOWFLAKEID_H

#include "SnowFlakeID_global.h"

#include <QDateTime>
#include <QtTypes>
#include <QDebug>


class SnowFlakeID
{
    /**
     * @brief SnowFlakeID is a resonably human readable a 128bit ID.
     *
     * The SnowFlake ID is human readable variant of a UUID. Instead of
     * every thing baked into a 128 bit number serie uninterpretable for
     * a human SnowFlakeID consists of:
     * * 64bit timecode (UTC MS since Unix EPOC) expressed in clear text
     * * 32 bit context expressed using proquints
     * * 32 bit random value
     *
     * The SnowFlakeID can also be expressed in a 128 bit unsigned int
     * using quint128 using the Hash() method.
     *
     * This is very similar to a UUID in content but expressed in mostly
     * human readable format.
     *
     * Eg:
     * Time    :  "2024-02-28, 17:43:42.612"
     * Context :  1208166479  quint:  "hobag-fodaz"
     * Random  :  1248698588  quint:  "honot-pagis"
     * Snowflake ID-string is:  "2024-02-28 17:57:14.513 radut-nasim tilug-jakud"
     * It can also be expressed as a JSON (or XMl or whatever):
     *  {
     *      "date"      = "2024-02-28"
     *      "time"      = "17:57:14.513"
     *      "context"   = "radut-nasi"
     *      "random"    = "tilug-jakud"
     *  }
     *
     *
     * References:
     * https://github.com/dsw/proquint/tree/master      Proquint coder/decoder
     * https://arxiv.org/html/0901.4016                 A Proposal for Proquints
     *
     */
    public:
        /**
         * @brief SnowFlakeID
         * Constructs a NULL SnowFlakeID
         */
        explicit SnowFlakeID();
        SnowFlakeID(const SnowFlakeID& other);
        ~SnowFlakeID();

        /**
         * @brief FromContext generates a new SnowFlakeID given a specific context.
         *
         * Creates a SnowFlakeID using the specified context.
         *
         * The Context must be valid, i.e. not zero. If a Zero Context is
         * provided, the returned SnowFlakeID will be NULL thus invalid.
         *
         * DateTime is fetched from the system time while Random is generated.
         *
         * @param context Context to be used for SnowFlakeID creation.
         * @return An valid SnowFlakeID given that the context is valid.
         */
        static SnowFlakeID FromContext(quint32 context);

        /**
         * @brief FromHash creates a SnowFlakedID from a 128 bit hash-value
         * Creates a mirror of the hashvalue. If hash-value contains null-fileds,
         * the result will be null.
         *
         * The string will be checked for conversion probability only, not for
         * valid content.
         * @param hash 128bit hash-value for a SnowFlakeID
         * @return A SnowFlakedID that can be NULL and Non Valid.
         */
        static SnowFlakeID FromHash(quint128 hash);


        /**
         * @brief FromHash creates a SnowFlakedID from a string hash-value
         * Creates a mirror of the hashvalue. If hash-value contains null-fileds,
         * the result will be null. No actual checks will be made.
         * @param hash 128bit hash-value for a SnowFlakeID
         * @return A SnowFlakedID that can be NULL and Non Valid.
         */
        static SnowFlakeID FromHash(QString hash);

        /**
         * @brief FromString creates a SnowFlakedID from a mostly human readable string value
         * Creates a mirror based on the string. If string contains null-fileds,
         * the result will be null. No actual checks will be made.
         * @param str String as generated by toString()
         * @return A SnowFlakedID that can be NULL and Non Valid.
         */
        static SnowFlakeID FromString(QString str);

        /**
         * @brief FromVariantMap creates a SnowFlakedID from a VariantMap
         * Creates a mirror based on the content of the map. If map contains null-fileds,
         * the result will be null. No actual checks on content will be made.
         * Checks will be made to ensure all parts are included in the map though.
         * @param map Map with fields to build the Flake.
         * @return A SnowFlakedID that can be NULL and Non Valid.
         */
        static SnowFlakeID FromVariantMap(QVariantMap map);

        /**
         * @brief GenerateContext generates a new random Context
         * @return A random context.
         */
        static quint32 GenerateContext();

        /**
         * @brief operator = Assignment operator
         * Copies contet field by field.
         * @param other Source to copy from
         * @return Referens to the assigned object.
         */
        SnowFlakeID& operator = (const SnowFlakeID& other);

        /**
         * @brief operator == compares two SnowFlakeIDs for equality
         * Compares two snowflakes for equality piece by piece.
         * Returns true if all pieces are the same, also if they are null
         * at the same places.
         * @param other Object to comapre with.
         * @return True if flakes are equal
         */
        bool operator == (const SnowFlakeID& other) const;

        /**
         * @brief operator << Streamoperator enables qDebug() on SnowFlakedIDs
         * @param d QDebug objekt used for printout.
         * @param flake object to print
         * @return Referens to d as expected for stream operators.
         */
        friend QDebug operator << (QDebug d, const SnowFlakeID& flake);

        /**
         * @brief toString generates a mostly human readable string value of the SnowFlakeID
         *
         * Generates a string in 4 parts:
         * * Date
         * * Time
         * * Context number using proquint
         * * Random number using proquint
         *
         * @return Mostly human readable string value of the Snow Flake ID
         */
        QString     toString() const;

        /**
         * @brief hash returns hash-value for the SnowFlakedID in integer format
         * @return 128bit hash-value for the SnowFlakedID in integer format
         */

        quint128    hash() const;

        /**
         * @brief hashString returns hash-value for the SnowFlakedID in string format
         * @return hash-value for the SnowFlakedID in string format
         */
        QString     hashString() const;

        /**
         * @brief isValid checks the SnowFaledID for validity.
         * Valid is if none of the fields are 0/null.
         * A Valid flake is not Null. A Null flake is not Valid.
         * @return
         */
        bool        isValid() const;

        /**
         * @brief isNull checks the SnowFaledID for validity.
         * Null is if any of the fields are 0/null.
         * A Valid flake is not Null. A Null flake is not Valid.
         * @return
         */
        bool        isNull() const;

        QVariantMap toVariant() const;


    protected:

        QDate           mDate;              // Creation date using UTC.
        QTime           mTime;              // Creation time using UTC.
        // QDateTime       mTimeStamp;         // Creation time with ms in UTC
        quint32         mContext;           // Context
        quint32         mRandom;            // Random

};


#endif // SNOWFLAKEID_H
